
#ifndef BTree23H
#define BTree23H

#include <iostream>
#include <string>
#include <list>
#include <queue>
//#include <math>

using namespace std;


#define NOVALUE -2147483647

typedef int tItem;

class tNode {
public:
	tItem SmallItem, LargeItem;
	tNode *pLeft, *pMiddle, *pRight, *pParent;
	
	tNode() {pLeft = NULL; pMiddle = NULL; pRight = NULL; pParent = NULL; SmallItem = NOVALUE; LargeItem = NOVALUE;};
	
	void SetChild(int intWhichChild, tNode *pChild);
	tNode* GetBrother(int intWhichBrother);		//intWhichBrother | 1 => deinj | 2 => 2  dein | -1 => kairj
	void tNode::RemoveChild(int intWhichChild);
};


class bTree23 {
	tNode *pRoot;
	
	list<tItem> GetListAsc(tNode *pNode);
	void Split(tNode *pNode, tItem Item, tNode *pLeftChild, tNode *pRightChild);		//reikia dl Insert
	void Split(tNode *pNode, tItem Item);												//kai dalinam virn
	void Fix(tNode *pNode);										//reikia dl Delete
	tNode* FindNextItemNode(tNode *pNode, tItem Item);			//nes gali reikti sukeisti vidins virns reikm su lapo reikme (imetant)
	tNode* Search(tNode *pNode, tItem Key, bool *pFound);
public:
	bTree23() {pRoot = NULL;};
	
	list<tItem> GetListAsc();
	list<tItem> GetListDesc();
	
	void Print(ostream *pOStream);
	void Read(istream *pIStream, bool bPrintTree);
	
	bool Search(tItem Key);
	
	int Insert(tItem Item);
	int Delete(tItem Item);
};

#endif